/* Copyright (C) 2000-2019 Hiroshi Watabe watabe@cyric.tohoku.ac.jp */
/* Header for PyBLD */
/* $Id: bld.h,v f68803db16f4 2019/07/28 23:00:14 watabe $ */
#include <Python.h>
#include <numpy/arrayobject.h>
#include <math.h>
float *array2float(PyArrayObject*);
float *array2float2d(PyArrayObject*);
float *array2float3d(PyArrayObject*);
float *array2float4d(PyArrayObject*);
double *array2double(PyArrayObject*);
float *array2float2d(PyArrayObject*);
int float2array2d(float*,PyArrayObject*);
int float2array3d(float*,PyArrayObject*);
int float2array4d(float*,PyArrayObject*);
int float2array1d(float*,PyArrayObject*);
int double2array2d(double*,PyArrayObject*);
int double2array1d(double*,PyArrayObject*);
float get_element(PyArrayObject*,int);
extern void interpolate_(int *,float *,float *,int *,float *,float *);
extern void integrate_(int *,float *,float *,int *,float *,float *);
void convexp(int *,float *,int *, float *,int *,float *,float *, float *);
void pconvexp(int *,float *,int *, float *,int *,float *,float *, float *);
void random_(float*, float*, float*);
void gauss_(float*, float*, float*);
int eval_func(double*,int);
int iter1(double*,double*, double*, double*, double*);
int iter2(double*,double*,double*,double*,double*,double*);
void convg1(double*,double*, double*);
void convg2(double*,double*,double*);
int subit(double*,double*,double*);
int testcg(double*,double*);
void stat_report(float*,int,int,float*,int,int,double,double,int*);
void showerror_(char*);
int dconex_(float*,float*,int*,int*,double*,double*,double*,double*,double*,int*);
int getdir(double*,int);
int mullin_(int,int,float*,float*,float*,double*,float*,char*,double*,double*,double*,double*,double*,float*);
int dmcpy_(double*,double*,int,int);
int dmmulk_(double*,double*,double,int,int);
int dmadd_(double*,double*,double*,int,int);
int dmmul_(double*,double*,double*,int,int,int);
int dminv_(double*,int,double*,double*,double*);
int diag_(double*,double*,int);
void sumsq(double*);

PyArrayObject *polfit(int, PyArrayObject*, PyArrayObject*, PyArrayObject*, int);
PyArrayObject *filter(PyArrayObject*,PyArrayObject*);
PyArrayObject *spline(PyArrayObject*,PyArrayObject*,PyArrayObject*);
PyArrayObject *fit(PyObject*, PyArrayObject*, PyArrayObject*, PyArrayObject*, PyArrayObject*, PyArrayObject*);


extern int fit_weight; /* whether we will do weight or not for general fitting */
extern double fit_dp; /* interval for numerical diff */
extern PyObject *fitfunc;
extern int fit_npar,fit_ndat,fit_puse;
extern double *fit_calc;
extern double *fit_diff;
extern double *fit_calc_pre;
extern double *fit_tm,*fit_pmat;
extern PyArrayObject *fit_tm_ar;
extern PyArrayObject *fit_par_ar;
extern double *fit_obs;
extern double *fit_wt;
extern unsigned char *fit_fixmat;
extern int num_iter;
extern int ktlx;
extern int fit_iterations,fit_subiterations;
extern unsigned char fit_func; /* which fitting function */
extern unsigned char show_flag; /* show detail or not */
extern float fit_converge;
extern unsigned char conv;
extern double *fit_semat;
extern double cur_ss;
extern double *fit_cormat;
extern double *fit_pcur; /*current param */
extern double report_mat[7];
