/* Convolution Exp BLD version */
/* Copyright (C) 2000-2007 Hiroshi Watabe watabe@ri.ncvc.go.jp */
/* $Id$ */
#include <Python.h>
#include "bld.h"

PyArrayObject *conv_exp(PyArrayObject *tm_array, PyArrayObject *par_array, PyArrayObject *a_array, PyArrayObject *b_array)
{
  int nx,npar,nbld;
  float *tm,*cnt,*a_tm,*newcnt,*par;
  PyArrayObject *result;
  npy_intp dimensions[1];

  import_array(); /* to make share array library */
  nx = tm_array->dimensions[0];
  npar = par_array->dimensions[0];
  nbld = a_array->dimensions[0];
  dimensions[0] = nx;
  result = (PyArrayObject *)PyArray_SimpleNew(1,dimensions,PyArray_FLOAT);
  newcnt = (float *)result->data;

  if((tm = array2float(tm_array))==NULL){
    PyErr_SetString(PyExc_MemoryError, "Failed to prepare variable tm");
    return NULL;
  }
  if((par = array2float(par_array))==NULL){
    PyErr_SetString(PyExc_MemoryError, "Failed to prepare variable par");
    return NULL;
  }
  if((a_tm = array2float(a_array))==NULL){
    PyErr_SetString(PyExc_MemoryError, "Failed to prepare variable a_tm");
    return NULL;
  }
  if((cnt = array2float(b_array))==NULL){
    PyErr_SetString(PyExc_MemoryError, "Failed to prepare variable cnt");
    return NULL;
  }
  convexp(&nx,tm,&npar,par,&nbld,a_tm,cnt,newcnt);
  free(cnt);
  free(par);
  free(tm);
  free(a_tm);
  return (PyArrayObject *)PyArray_Return(result);
}
