/* PyBLD version of filter based on bld filter.f*/
/* Copyright (C) 2000-2007 Hiroshi Watabe watabe@ri.ncvc.go.jp */
/* $Id$ */
#include "bld.h"

int bldfilter_(int*,float*, float*, float*,int*);

PyArrayObject *filter(PyArrayObject *x_ar,PyArrayObject *y_ar)
{
  int ndim[4];
  npy_intp dimensions[2];
  float *x,*y,*fmat;
  PyArrayObject *res_ar;
  int ret;
  int type;

  import_array();	
  if(x_ar->nd==1){
    ndim[1] = x_ar->dimensions[0];
    ndim[0] = 1;
  }
  else{
    ndim[0] = x_ar->dimensions[0];
    ndim[1] = x_ar->dimensions[1];
  }
  if(x_ar->nd==1){
    ndim[3] = y_ar->dimensions[0];
    ndim[2] = 1;
  }
  else{
    ndim[2] = y_ar->dimensions[0];
    ndim[3] = y_ar->dimensions[1];
  }
  if(ndim[0]==1){
    x = array2float(x_ar);
  }
  else{
    x = array2float2d(x_ar);
  }
  if(ndim[2]==1){
    y = array2float(y_ar);
  }
  else{
    y = array2float2d(y_ar);
  }
  fmat = (float *)malloc(ndim[0]*ndim[1]*sizeof(float));
  if(fmat==NULL){
    PyErr_SetString(PyExc_MemoryError, "Failed to allocate memory");
    return NULL;
  }
  memset(fmat,0,ndim[0]*ndim[1]*sizeof(float));
  ret = 0;
  bldfilter_(ndim,x,y,fmat,&ret);
  if(ret == -1){
    PyErr_SetString(PyExc_ValueError, "Filter dimensions should be odd");
    return NULL;
  }
  dimensions[0] = ndim[0];
  dimensions[1] = ndim[1];
  type = NPY_FLOAT;
  res_ar = (PyArrayObject *)PyArray_SimpleNew(2,dimensions,type);
  float2array2d(fmat,res_ar);
  free(x);
  free(y);
  free(fmat);
  return (PyArrayObject *)PyArray_Return(res_ar);
}
