/* Integration BLD version */
/* Copyright (C) 2000-2007 Hiroshi Watabe watabe@ri.ncvc.go.jp */
/* $Id$ */
#include "bld.h"

PyArrayObject *integrate(PyArrayObject *tm_array, PyArrayObject *cnt_array, PyArrayObject *out_array)
{
  int in_n;
  int out_n;
  float *tm,*cnt,*newtm,*newcnt;
  PyArrayObject *result;
  npy_intp dimensions[1];

  import_array(); /* to make share array library */
  in_n = tm_array->dimensions[0];
  out_n = out_array->dimensions[0];

  if((tm = array2float(tm_array))==NULL){
    PyErr_SetString(PyExc_MemoryError, "Failed to prepare variable tm");
    return NULL;
  }
  if((cnt = array2float(cnt_array))==NULL){
    PyErr_SetString(PyExc_MemoryError, "Failed to prepare variable cnt");
    return NULL;
  }
  if((newtm = array2float(out_array))==NULL){
    PyErr_SetString(PyExc_MemoryError, "Failed to prepare variable newtm");
    return NULL;
  }
  dimensions[0] = out_n;
  result = (PyArrayObject *)PyArray_SimpleNew(1,dimensions,PyArray_FLOAT);
  newcnt = (float *)result->data;
  integrate_(&in_n,tm,cnt,&out_n,newtm,newcnt);
  free(cnt);
  free(newtm);
  free(tm);
  return (PyArrayObject *)PyArray_Return(result);
}
