/* random function BLD version */
/* Copyright (C) 2000-2007 Hiroshi Watabe watabe@ri.ncvc.go.jp */
/* $Id$ */
#include <stdlib.h>
#include "bld.h"

PyArrayObject *gaus(PyArrayObject *avg_ar, PyArrayObject *sd_ar,int iseed)
{
  int n1,n2,nd1,nd2,nans,i;
  PyArrayObject *result;
  npy_intp dimensions[1];
  float *avg,*sd,*rnd;

  import_array(); /* to make share array library */
  srand(iseed);
  nd1 = avg_ar->nd;
  nd2 = sd_ar->nd;
  n1 = avg_ar->dimensions[0];
  n2 = sd_ar->dimensions[0];
  if((nd1==1)&&(nd2==1)&&(n1==1)&&(n2==1)){
    avg = array2float(avg_ar);
    sd = array2float(sd_ar);
    dimensions[0] = 1;
    result = (PyArrayObject *)PyArray_SimpleNew(1,dimensions,PyArray_FLOAT);
    rnd = (float *)result->data;
    gauss_(avg,sd,rnd);
    free(avg);
    free(sd);
    return (PyArrayObject *)PyArray_Return(result);
  }
  n1 = avg_ar->dimensions[0];
  n2 = sd_ar->dimensions[0];
  if(n1==1){
    nans = n2;
    avg = (float *)malloc(sizeof(float)*nans);
    if(avg == NULL){
      PyErr_SetString(PyExc_MemoryError, "Cannot allocate memory");
      return NULL;
    }
    for(i=0;i<nans;i++){
      avg[i] = get_element(avg_ar,0);
    }
    sd = array2float(sd_ar);
  }
  else{
    if(n2==1){
      nans = n1;
      sd = (float *)malloc(sizeof(float)*nans);
      if(sd == NULL){
	PyErr_SetString(PyExc_MemoryError, "Cannot allocate memory");
	return NULL;
      }
      for(i=0;i<nans;i++){
	sd[i] = get_element(sd_ar,0);
      }
      avg = array2float(avg_ar);
    }
    else{
      if(n1 == n2){
	nans = n1;
	avg = array2float(avg_ar);
	sd = array2float(sd_ar);
      }
      else{
	PyErr_SetString(PyExc_ValueError, "Failed to make random");
	return NULL;
      }
    }
  }
  dimensions[0] = nans;
  result = (PyArrayObject *)PyArray_SimpleNew(1,dimensions,PyArray_FLOAT);
  rnd = (float *)result->data;
  for(i=0;i<nans;i++){
    gauss_(&avg[i],&sd[i],&rnd[i]);
  }

  free(avg);
  free(sd);
  return (PyArrayObject *)PyArray_Return(result);
}

PyArrayObject *ran(PyArrayObject *x1_ar, PyArrayObject *x2_ar,int iseed)
{
  int n1,n2,nd1,nd2,nans,i;
  PyArrayObject *result;
  npy_intp dimensions[1];
  float *x1mat,*x2mat,*rnd;

  import_array(); /* to make share array library */
  srand(iseed);
  nd1 = x1_ar->nd;
  nd2 = x2_ar->nd;
  n1 = x1_ar->dimensions[0];
  n2 = x2_ar->dimensions[0];
  if((nd1==1)&&(nd2==1)&&(n1==1)&&(n2==1)){
    x1mat = array2float(x1_ar);
    x2mat = array2float(x2_ar);
    dimensions[0] = 1;
    result = (PyArrayObject *)PyArray_SimpleNew(1,dimensions,PyArray_FLOAT);
    rnd = (float *)result->data;
    random_(x1mat,x2mat,rnd);
    free(x1mat);
    free(x2mat);
    return (PyArrayObject *)PyArray_Return(result);
  }
  n1 = x1_ar->dimensions[0];
  n2 = x2_ar->dimensions[0];
  if(n1==1){
    nans = n2;
    x1mat = (float *)malloc(sizeof(float)*nans);
    if(x1mat == NULL){
      PyErr_SetString(PyExc_MemoryError, "Cannot allocate memory");
      return NULL;
    }
    for(i=0;i<nans;i++){
      x1mat[i] = get_element(x1_ar,0);
    }
    x2mat = array2float(x2_ar);
  }
  else{
    if(n2==1){
      nans = n1;
      x2mat = (float *)malloc(sizeof(float)*nans);
      if(x2mat == NULL){
	PyErr_SetString(PyExc_MemoryError, "Cannot allocate memory");
	return NULL;
      }
      for(i=0;i<nans;i++){
	x2mat[i] = get_element(x2_ar,0);
      }
      x1mat = array2float(x1_ar);
    }
    else{
      if(n1 == n2){
	nans = n1;
	x1mat = array2float(x1_ar);
	x2mat = array2float(x2_ar);
      }
      else{
	PyErr_SetString(PyExc_ValueError, "Failed to make random");
	return NULL;
      }
    }
  }
  rnd = (float *)malloc(sizeof(float)*nans);
  if(rnd == NULL){
    PyErr_SetString(PyExc_MemoryError, "Cannot allocate memory");
    return NULL;
  }
  for(i=0;i<nans;i++){
    gauss_(&x1mat[i],&x2mat[i],&rnd[i]);
  }

  dimensions[0] = nans;
  result = (PyArrayObject *)PyArray_SimpleNew(1,dimensions,PyArray_FLOAT);
  for(i=0;i<nans;i++){
    (*(float *)(result->data + i*result->strides[0])) = (float)rnd[i];
  }
  return (PyArrayObject *)PyArray_Return(result);
}
