/* Copyright (C) 2000-2007 Hiroshi Watabe watabe@ri.ncvc.go.jp */
/* filter.c generated from f2c and filter.f */
/* $Id$ */
/* $Date: 2003-06-12 07:13:11 +0900 (木, 12  6月 2003) $ */

#include "bld.h"
#define MAX(a,b) (a > b ? a : b)
#define MIN(a,b) (a < b ? a : b)

int do_filt__(int*, int*, float*, int*, int*, float*, float*);

/*  filter.for  bld external task to filter something */
/* Subroutine */ int bldfilter_(ndim, rmat, filter, retadr, ierr)
int *ndim;
float *rmat, *filter, *retadr;
int *ierr;
{
    static int ncol, nrow;
    static int ncol_f__, nrow_f__;


    /* Function Body */
    if(ndim[0]==1){ /* 1dimensional */
      nrow = ndim[1];
      ncol = ndim[0];
    }
    else{
      nrow = ndim[0];
      ncol = ndim[1];
    }
    if(ndim[2]==1){ /* 1dimensional */
      nrow_f__ = ndim[3];
      ncol_f__ = ndim[2];
    }
    else{
      nrow_f__ = ndim[2];
      ncol_f__ = ndim[3];
    }

    if (nrow_f__ % 2 != 1 || ncol_f__ % 2 != 1) {
      *ierr = -1;
      return 0;
    } else {
      do_filt__(&nrow, &ncol, rmat, &nrow_f__, &ncol_f__, filter, retadr);
    }
    return 0;
}

int do_filt__(nr, nc, x, nrf, ncf, f, y)
int *nr, *nc;
float *x;
int *nrf, *ncf;
float *f, *y;
{
    /* System generated locals */
  int x_dim1, f_dim1, y_dim1, i__1, i__2, 
    i__3, i__4, i__5, i__6, i__7, i__8;
    /* Local variables */
    static int ic, jc, ir, jr;
    static float yy;
    static int nc1, nr1;

    /* Parameter adjustments */
    y_dim1 = *nr;
    x_dim1 = *nc;
    f_dim1 = *nrf;

    /* Function Body */
    nc1 = *ncf / 2;
/* half dimen of filter by column */
    nr1 = *nrf / 2;

/* loop through image */

/* half dimen of filter by row */
    i__1 = *nc;
    i__2 = *nr;
    for (ic = 1; ic <= i__1; ++ic) {
	for (ir = 1; ir <= i__2; ++ir) {

/*  doing col ic , row ir */
/* 	loop through filter sized rectange around it */

	    yy = (float)0.;
/* Computing MAX */
	    i__3 = 1, i__4 = ic - nc1;
/* Computing MIN */
	    i__6 = *nc, i__7 = ic + nc1;
	    i__5 = MIN(i__6,i__7);
	    for (jc = MAX(i__3,i__4); jc <= i__5; ++jc) {
/* Computing MAX */
		i__3 = 1, i__4 = ir - nr1;
/* Computing MIN */
		i__7 = *nr, i__8 = ir + nr1;
		i__6 = MIN(i__7,i__8);
		for (jr = MAX(i__3,i__4); jr <= i__6; ++jr) {
		    yy += x[jr - 1 + (jc - 1) * x_dim1] * f[jr - ir + nr1  + (jc - 
			    ic + nc1) * f_dim1];
		}
	    }
	    y[(ic - 1)*i__1 + (ir - 1)] = yy;
	}
    }
    return 0;
}

