/* PyBLD image transformation*/
/* Copyright (C) 2000-2010 Hiroshi Watabe watabe@ri.ncvc.go.jp */
/* $Id$ */
#include "bld.h"

void img_transform(float *imgmat,npy_intp *dimen,float *sizmat, float* trmat,float *resmat){
  int xdim,ydim,zdim,tdim,i,j,k,l;
  float pxsiz,pysiz,pzsiz;
  double dx1,dy1,dz1,dx2,dy2,dz2;
  float tmatrix[3][4];
  float newx,newy,newz,origx,origy,origz;
  int ix1,iy1,iz1,ix2,iy2,iz2;
  float p111,p112,p121,p122,p211,p212,p221,p222;

  xdim = dimen[3];
  ydim = dimen[2];
  zdim = dimen[1];
  tdim = dimen[0];

  pxsiz = sizmat[0];
  pysiz = sizmat[1];
  pzsiz = sizmat[2];

  tmatrix[0][0] = trmat[0];
  tmatrix[0][1] = trmat[1];
  tmatrix[0][2] = trmat[2];
  tmatrix[0][3] = trmat[3];
  tmatrix[1][0] = trmat[4];
  tmatrix[1][1] = trmat[5];
  tmatrix[1][2] = trmat[6];
  tmatrix[1][3] = trmat[7];
  tmatrix[2][0] = trmat[8];
  tmatrix[2][1] = trmat[9];
  tmatrix[2][2] = trmat[10];
  tmatrix[2][3] = trmat[11];
  for (l=0;l<tdim;l++){
    for (i=0;i<zdim;i++){
      origz = i*pzsiz;
      for(j=0;j<ydim;j++){
	origy = j*pysiz;
	for(k=0;k<xdim;k++){
	  origx = k*pxsiz;
	  newx =  (tmatrix[0][0]*origx + tmatrix[0][1]*origy + tmatrix[0][2]*origz + tmatrix[0][3])/pxsiz;
	  newy =  (tmatrix[1][0]*origx + tmatrix[1][1]*origy + tmatrix[1][2]*origz + tmatrix[1][3])/pysiz;
	  newz =  (tmatrix[2][0]*origx + tmatrix[2][1]*origy + tmatrix[2][2]*origz + tmatrix[2][3])/pzsiz;
	  ix1 = (int)newx;
	  iy1 = (int)newy;
	  iz1 = (int)newz;
	  dx2 = newx - ix1;
	  dy2 = newy - iy1;
	  dz2 = newz - iz1;
	  dx1 = 1.0 - dx2;
	  dy1 = 1.0 - dy2;
	  dz1 = 1.0 - dz2;
	  ix2 = ix1 + 1;
	  iy2 = iy1 + 1;
	  iz2 = iz1 + 1;
	  if(ix2<0||iy2<0||iz2<0||ix2>xdim||iy2>ydim||iz2>zdim){//out of image
	    continue;
	  }
	  if(ix1>=0&&iy1>=0&&iz1>=0&&ix2<xdim&&iy2<ydim&&iz2<zdim){
	    p111 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz1 + xdim*iy1 + ix1];
	    p112 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz1 + xdim*iy1 + ix2];
	    p121 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz1 + xdim*iy2 + ix1];
	    p122 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz1 + xdim*iy2 + ix2];
	    p211 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz2 + xdim*iy1 + ix1];
	    p212 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz2 + xdim*iy1 + ix2];
	    p221 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz2 + xdim*iy2 + ix1];
	    p222 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz2 + xdim*iy2 + ix2];
	    resmat[xdim*ydim*zdim*l + xdim*ydim*i + xdim*j + k] = (float)(p111*dx1*dy1*dz1 + p112*dx2*dy1*dz1 + p121*dx1*dy2*dz1 + p122*dx2*dy2*dz1 + p211*dx1*dy1*dz2 + p212*dx2*dy1*dz2 + p221*dx1*dy2*dz2 + p222*dx2*dy2*dz2);
	  }
	  if(ix2==0&&iy1>=0&&iz1>=0&&ix2<xdim&&iy2<ydim&&iz2<zdim){
	    p112 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz1 + xdim*iy1 + ix2];
	    p122 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz1 + xdim*iy2 + ix2];
	    p212 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz2 + xdim*iy1 + ix2];
	    p222 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz2 + xdim*iy2 + ix2];
	    resmat[xdim*ydim*zdim*l + xdim*ydim*i + xdim*j + k] = (float)(p112*dy1*dz1 + p122*dy2*dz1 + p212*dy1*dz2 + p222*dy2*dz2);
	  }
	  if(ix1>=0&&iy2==0&&iz1>=0&&ix2<xdim&&iy2<ydim&&iz2<zdim){
	    p121 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz1 + xdim*iy2 + ix1];
	    p122 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz1 + xdim*iy2 + ix2];
	    p221 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz2 + xdim*iy2 + ix1];
	    p222 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz2 + xdim*iy2 + ix2];
	    resmat[xdim*ydim*zdim*l + xdim*ydim*i + xdim*j + k] = (float)(p121*dx1*dz1 + p122*dx2*dy2*dz1 + p221*dx1*dz2 + p222*dx2*dz2);
	  }
	  if(ix1>=0&&iy1>=0&&iz2==0&&ix2<xdim&&iy2<ydim&&iz2<zdim){
	    p211 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz2 + xdim*iy1 + ix1];
	    p212 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz2 + xdim*iy1 + ix2];
	    p221 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz2 + xdim*iy2 + ix1];
	    p222 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz2 + xdim*iy2 + ix2];
	    resmat[xdim*ydim*zdim*l + xdim*ydim*i + xdim*j + k] = (float)(p211*dx1*dy1 + p212*dx2*dy1 + p221*dx1*dy2 + p222*dx2*dy2);
	  }
	  if(ix1>=0&&iy1>=0&&iz1>=0&&ix2==xdim&&iy2<ydim&&iz2<zdim){
	    p111 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz1 + xdim*iy1 + ix1];
	    p121 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz1 + xdim*iy2 + ix1];
	    p211 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz2 + xdim*iy1 + ix1];
	    p221 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz2 + xdim*iy2 + ix1];
	    resmat[xdim*ydim*zdim*l + xdim*ydim*i + xdim*j + k] = (float)(p111*dy1*dz1 + p121*dy2*dz1 + p211*dy1*dz2 + p221*dy2*dz2);
	  }
	  if(ix1>=0&&iy1>=0&&iz1>=0&&ix2<xdim&&iy2==ydim&&iz2<zdim){
	    p111 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz1 + xdim*iy1 + ix1];
	    p112 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz1 + xdim*iy1 + ix2];
	    p211 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz2 + xdim*iy1 + ix1];
	    p212 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz2 + xdim*iy1 + ix2];
	    resmat[xdim*ydim*zdim*l + xdim*ydim*i + xdim*j + k] = (float)(p111*dx1*dz1 + p112*dx2*dz1 + p211*dx1*dz2 + p212*dx2*dz2);
	  }
	  if(ix1>=0&&iy1>=0&&iz1>=0&&ix2<xdim&&iy2<ydim&&iz2==zdim){
	    p111 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz1 + xdim*iy1 + ix1];
	    p112 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz1 + xdim*iy1 + ix2];
	    p121 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz1 + xdim*iy2 + ix1];
	    p122 = imgmat[xdim*ydim*zdim*l + xdim*ydim*iz1 + xdim*iy2 + ix2];
	    resmat[xdim*ydim*zdim*l + xdim*ydim*i + xdim*j + k] = (float)(p111*dx1*dy1 + p112*dx2*dy1 + p121*dx1*dy2 + p122*dx2*dy2);
	  }
	}
      }
    }
  }
}

PyArrayObject *transform(PyArrayObject *imgar,PyArrayObject *sizar,PyArrayObject *trar)
{
  npy_intp dimensions[4];
  float *imgmat,*sizmat,*trmat,*resmat;
  PyArrayObject *res_ar;
  int xdim,ydim,zdim,tdim,nd;

  import_array();
  nd = 	imgar->nd; //number of dimension

  if(nd==4){
    imgmat = array2float4d(imgar);
  }
  else{
    imgmat = array2float3d(imgar);
  }
  if(imgmat==NULL){
    return NULL;
  }
  if(nd==4){
    tdim = (int)imgar->dimensions[0];
    zdim = (int)imgar->dimensions[1];
    ydim = (int)imgar->dimensions[2];
    xdim = (int)imgar->dimensions[3];
  }
  else{
    tdim = 1;
    zdim = (int)imgar->dimensions[0];
    ydim = (int)imgar->dimensions[1];
    xdim = (int)imgar->dimensions[2];
  }
  resmat = (float *)malloc((long)(xdim*ydim*zdim*tdim*sizeof(float)));
  if(resmat==NULL){
    PyErr_SetString(PyExc_MemoryError, "Failed to allocate memory in image transform");
    return NULL;
  }
  memset(resmat,0,xdim*ydim*zdim*tdim*sizeof(float));

  sizmat = array2float(sizar);
  trmat = array2float(trar);
  dimensions[3] = xdim;
  dimensions[2] = ydim;
  dimensions[1] = zdim;
  dimensions[0] = tdim;
  //  printf("%g %g\n",imgmat[xdim*ydim*zdim*(tdim -1)],resmat[xdim*ydim*zdim*(tdim -1)]);
  img_transform(imgmat,dimensions,sizmat,trmat,resmat);
  if(nd==3){
    dimensions[0] = zdim;
    dimensions[1] = ydim;
    dimensions[2] = xdim;
    res_ar = (PyArrayObject *)PyArray_SimpleNew(3,dimensions,PyArray_FLOAT);
    float2array3d(resmat,res_ar);
  }
  if(nd==4){
    res_ar = (PyArrayObject *)PyArray_SimpleNew(4,dimensions,PyArray_FLOAT);
    float2array4d(resmat,res_ar);
  }
  free(sizmat);
  free(trmat);
  free(imgmat);
  free(resmat);
  return (PyArrayObject *)PyArray_Return(res_ar);
}
