%module pybldc
%inline %{
/* global variables */
extern int fit_weight,fit_const;
extern double fit_dp; /* interval for numerical diff */
extern int fit_iterations,fit_subiterations;
extern unsigned char fit_func;
extern float fit_converge;
extern unsigned char show_flag;
%}

%{
#include <numpy/arrayobject.h>
#include "bld.h"
#include "bld_funcs.h"
%}
%init %{
        import_array();
%}
#if defined(SWIGPYTHON)
%typemap(in) PyArrayObject * {
  $1 = (PyArrayObject *)$input;
}
#endif
#if defined(SWIGPYTHON)
%typemap(out) PyArrayObject * {
  $result = (PyObject *)$1;
}
#endif

/* following routine is for calling fitfunction */
%{
PyArrayObject *callfitfunc(PyArrayObject *x,PyArrayObject *y, void *clientdata)
{
   PyObject *func, *arglist;
   PyArrayObject *result;
   
   func = (PyObject *) clientdata;
   arglist = Py_BuildValue("OO",x,y);
   result = (PyArrayObject *)PyEval_CallObject(func,arglist);
   Py_DECREF(arglist);
   return result;
}

%}
#if defined(SWIGPYTHON)
%typemap(in) PyObject *PyFunc {
/* Jun04-2000 for expfit */
  if (fit_func==0){
        $1 = NULL;
  }
  else{
    if (!PyCallable_Check($input)) {
        PyErr_SetString(PyExc_TypeError, "Need a callable object!");
        return NULL;
    }
    $1 = $input;
 }
}
#endif

%include "bld_funcs.h"
