/* generate  gauss funciton based on BLD source random.for */
/* Copyright (C) 2000-2007 Hiroshi Watabe watabe@ri.ncvc.go.jp */
/* $Id$ */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "bld.h"

void random_(float *a, float *b, float *x)
{
  /*
C  RANDOM.FOR - ROUTINES FOR GENERATION OF PSEUDO RANDOM NOISE
C
C  Last Edit     :  30-JAN-82
C  Application   :  BLD
C  Author        :  RE CARSON
C  Modifications :  
C  ------------------------------------------------------------------------
C  MODULES IN THIS FILE: RANDOM  GAUSS
C  ------------------------------------------------------------------------
C
C  THE MODULES IN THIS SOURCE FILE SUPPLY THE BLD BUILT-IN FUNCTIONS
C	FOR UNIFORM RANDOM NOISE AND GAUSSIAN RANDOM NOISE
C
C  RANDOM(A,B,SEED,X) - THIS SUBROUTINE RETURNS A RANDOM NUMBER
C	UNIFORMLY DISTRIBUTED BETWEEN 'A' AND 'B' IN THE ARGUMENT 'X'.
C	THE ARGUMENT 'SEED' IS USED TO DRIVE THE PSEUDO RANDOM NUMBER
C	GENERATOR AND IS MODIFIED BY THE ROUTINE
  */
  float rnd;

  rnd = rand()/(float)RAND_MAX;
  *x = *a + (*b - *a)*(rnd);
}

void gauss_(float *xm,float *sd,float *x)
{
  /*
C  GAUSS(XM,SD,SEED,X) - THIS SUBROUTINE RETURNS A RANDOM NUMBER IN THE
C	ARGUMENT 'X' FROM A GAUSSIAN DISTRIBUTION WITH MEAN 'XM' AND
C	STANDARD DEVIATION 'SD'.  THE ARGUMENT 'SEED' IS USED TO DRIVE 
C	THE PSEUDO RANDOM NUMBER GENERATOR AND IS MODIFIED BY THE ROUTINE.
C	THIS ROUTINE WORKS BY SUMMING 12 UNIFORM RANDOM NUMBERS.
  */
  int n = 12;
  int i;
  float b1,b2,b,a,x1;

  *x = 0.0;
  b2 = (float)(fabs((double)(*sd))*sqrt(3.0/(double)(n)));
  b1 = (float)(*xm)/(float)n;
  b = b1 + b2;
  a = b1 - b2;
  for(i=0;i<n;i++){
    random_(&a,&b,&x1);
    *x += x1;
  }
}
